#Compile Exe              'This app hosts a simple custom control housed in dllCustomControlServer.dll.
#Dim All                  'This is a fairly simple control that does not even export any functions, and
#Include "Win32api.inc"   'all communication between the control and this app is through Windows messaging.
%IDC_BUTTON1              =1300           'Control ID For Blue' Button
%IDC_BUTTON2              =1305           'Control ID For Green' Button
%IDC_BUTTON3              =1310           'Control ID For Red' Button
%FORM1_CUSTOM1            =1315           'Control ID For Custom Control
%MY_CUSTOM_MESSAGE        =1500           'Custom User Defined Message For Custom Control
%MY_CUS_MSG_LBUTTON_DOWN  =1505           'and another
Declare Function blnInitialize Lib "dllCustomControlServer" Alias "blnInitialize" () As Long
Global hDll As Dword      'When Microsoft created their suite of 'Common Controls' such as the.........


Type WndEventArgs         '...SysMonthCal control, Tab control, etc., they realized that more complicated
  wParam As Long          'information needed to be passed between the host of the control and the control
  lParam As Long          'itself than could be handled by the wParam and lParam parameters to the Window
  hWnd   As Dword         'procedure that are such a basic part of the Windows messaging mechanism used by
  hInst  As Dword         'simpler controls such as edit boxes and listboxes.  What they did was create a
End Type                  'new WM_ message named WM_NOTIFY that the custom control would send to its host...


Type WindowColor          'Associated with this WM_NOTIFY message is a wParam and lParam just like with all
  lpnmh As NMHDR          'messages.  However, the lParam will hold a pointer to a large type/structure whose
  szColor As Asciiz*16    'fields are unique to whatever functionality the custom control exposes.  Since this
End Type                  'apps's custom control only manifests itself as a colored window, it only exposes...


Function fnWndProc_OnCreate(wea As WndEventArgs) As Long
  Local pCreateStruct As CREATESTRUCT Ptr
  Local hButton As Dword    '...a simple type/structure with a field for window color, i.e., szColor (see type WindowColor
  Local dwStyle As Dword    'left above).  But the standard created by Microsoft is that the first member of this user
  Local hCus As Dword       'created type/structure should be a Microsoft defined structure named NMHDR (New Msg Handler).
  Register i As Long        'It looks like this...

  pCreateStruct=wea.lParam                'Type NMHDR
  wea.hInst=@pCreateStruct.hInstance      '  hwndFrom  As Dword
  'hDLL= _                                 '  idfrom    As Dword
  'LoadLibrary _                           '  code      As Long
  '( _                                     'End Type                  continued below...
  '  "dllCustomControlServer.dll" _
  ')
  'if hDLL Then
  If blnInitialize() Then
     hButton=CreateWindowEx(0,"button","Blue",%WS_CHILD Or %WS_VISIBLE,8,10,80,25,wea.hWnd,%IDC_BUTTON1,wea.hInst,ByVal 0)
     hButton=CreateWindowEx(0,"button","Green",%WS_CHILD Or %WS_VISIBLE,8,40,80,25,wea.hWnd,%IDC_BUTTON2,wea.hInst,ByVal 0)
     hButton=CreateWindowEx(0,"button","Red",%WS_CHILD Or %WS_VISIBLE,8,70,80,25,wea.hWnd,%IDC_BUTTON3,wea.hInst,ByVal 0)
     dwStyle=%WS_CHILD Or %WS_VISIBLE Or %WS_THICKFRAME
     hCus= _
     CreateWindowEx _       '...Interupting for a moment our discussion of NMHDR, note that just left is the CreateWindow
     ( _                    'call that instantiates our custom control located in the dll.  A custom control is created just
       %WS_EX_CLIENTEDGE, _ 'like any other control - through a CreateWindow() call.  Note that the 2nd parameter of the
       "Custom_Control", _  'CreateWindowEx() call is the registered class name of the custom control in the dll - here
       "", _                'Custom_Control.  I'll discuss that issue in the dll code.  But returning again to NMHDR, there
       dwStyle, _           'will be a window procedure within the dll for the custom control.  This window procedure will
       100, _               'receive Windows messages such as mouse movements, button clicks, etc., just like any window
       12, _                'procedure.  These windows messages received within the window procedure of the custom control
       325, _               'in the dll will be transferred/sent back to the host app in slightly modified form through this
       80, _                'NMHDR structure.  It might be instructive at this point to examine the WM_LBUTTONDOWN code in
       wea.hWnd, _          'ControlClassWndProc in the dllCustomControlServer.bas file to see what happens when a LButtonDown
       %FORM1_CUSTOM1, _    'occurs over the custom control.  First off you may note that a local variable of type WindowColor
       wea.hInst, _         'is declared at the top of the window procedure.  This type contains as its 1st member a NMHDR
       ByVal 0 _            'structure named lpnmh.  The 2nd member is an asciiz buffer to hold the color of the custom control.
     )                      'When a left button down occurs the NMHDR is filled out with the hWnd and CtrlID of the custom,
  Else                      'as well as a member we have not discussed yet named 'code'.  What goes here is a custom control
     MsgBox("Dll Load Failure!")
     PostQuitMessage 0      'defined message that will inform the host of what exactly happened in the custom control.
     Function=-1            'In this case a WM_LBUTTONDOWN occurred.  A custom message equate is defined in both the dll and the
     Exit Function          'host for this scenerio, e.g., %MY_CUS_MSG_LBUTTON_DOWN = 1505.  This gets assigned to the
  End If                    'wc.lpnmh.code member.  The next thing that happens is that the cbWndExtra bytes (0-3) of the

  fnWndProc_OnCreate=0      'custom control's Window Class structure are queried for the RGB value stored there.  Four bytes
End Function                'of cbWndExtra storage were allocated in the Window Class structure for this purpose of storing...


'Event Handler For Click Of 'Blue' Button     '...the custom control's current color.  Select Case logic then translates the
Sub btnBlue_Click(wea As WndEventArgs)        'retrieved RGB value into an Asciiz string such as 'Red', 'Green', 'Blue', etc.
  Call SendMessage _                          'This string is then assigned to the wc.szColor member of the WindowColor type.
  ( _                                         'Then something critical happens.  This SendMessage() call is made...
    GetDlgItem(wea.hWnd,%FORM1_CUSTOM1), _    '
    %MY_CUSTOM_MESSAGE, _                     'SendMessage(GetParent(hWnd), %WM_NOTIFY, GetDlgCtrlID(hWnd), VarPtr(wc))
    RGB(0,0,255),0 _                          '
  )                                           'The 1st parameter will obtain the parent of the custom control which is the
End Sub                                       'client or this host app.  The 2nd parameter is the message to be sent to .....


'Event Handler For Click Of 'Green' Button    '...this app, and that would be the WM_NOTIFY message we have been discussing all
Sub btnGreen_Click(wea As WndEventArgs)       'along.  When this app receives a WM_NOTIFY message it will know that a message
  Call SendMessage _                          'from some custom control has arrived.  The 3rd parameter (wParam) of the
  ( _                                         'SendMessage() call is the control id of the particular custom control sending
    GetDlgItem(wea.hWnd,%FORM1_CUSTOM1), _    'the message.  The 4th parameter is the most important.  This would be the address
    %MY_CUSTOM_MESSAGE, _                     'of the wc WindowColor variable in the Window Procedure of the custom control.  And
    RGB(0,255,0), _                           'it is this variable that currently holds all the unique custom control 'state'
    0 _                                       'information of which the custom control wishes to make its host aware.  Note that
  )                                           'the Varptr(wc) was transferred back through this lParam parameter which is in
End Sub                                       'keeping with Windows typical use of this variable which is after all ultimately


'Event Handler For Click Of 'Red' Button      '...defined as a pointer variable in various windows header files.  So that explains
Sub btnRed_Click(wea As WndEventArgs)         'what happens in the dll when you click the mouse button over the custom control.
  Call SendMessage _                          'What needs to be explained here now in the host app is what happens when the buttons
  ( _                                         'just to the left of the custom control are clicked, and how the WM_NOTIFY handler
    GetDlgItem(wea.hWnd,%FORM1_CUSTOM1), _    'here works.  We'll start with the former being as the button click handlers are
    %MY_CUSTOM_MESSAGE, _                     'just to the left of these words you are reading.  First realize that the three
    RGB(255,0,0), _                           'buttons aren't part of the custom control.  They are located within this app and
    0 _                                       'are children of this app's main form.  When one of them is clicked this main form's
  )                                           'Window Procedure receives its typical WM_COMMAND message and logic then routes
End Sub                                       'program execution to one of these three button message handlers just to the left.


'Event Handler For %WM_COMMAND Messages       'What then happens is another SendMessage() Api call but this time the message is
Function fnWndProc_OnCommand(wea As WndEventArgs) As Long  'being sent to the custom control.  And the message being sent is
  Select Case LoWrd(wea.wParam)               'another custom control defined message - not a standard windows message. The
    Case %IDC_BUTTON1                         'message is defined both here and in the dll as follows - %MY_CUSTOM_MESSAGE=1500.
      Call btnBlue_Click(wea)                 'The third parameter (wParam) of the SendMessage() call is the RGB value that the
    Case %IDC_BUTTON2                         'host (this app) wants the custom control to draw itself, i.e., blue, green, or
      Call btnGreen_Click(wea)                'red.  Referring back to the Window Procedure within the dll in
    Case %IDC_BUTTON3                         'dllCustomControlServer.bas, you'll note a case - Case %MY_CUSTOM_MESSAGE - and
      Call btnRed_Click(wea)                  'this SendMessage() call from here will be 'picked up' there.  What then happens
  End Select                                  'is the RGB value placed here in the host in the wParam of the SendMessage() call

  fnWndProc_OnCommand=0                       'is stored there in the custom control in its previously allocated cbWndExtra
End Function                                  'bytes.  Then an InvalidateRect() call is finally made and this forces a WM_PAINT...


Function fnWndProc_OnNotify(wea As WndEventArgs) As Long '..within the custom control where the RGB value is retrieved from
  Local wc As WindowColor Ptr                            'the cbWndExtra bytes, a colored brush of the desired color created,

  wc=wea.lParam                                          'and the window finally painted the desired color.  Well, that was a
  Select Case As Long @wc.lpnmh.idFrom                   'mouthful but it brings us to fnWndProc_OnNotify() just to the left.
    Case %FORM1_CUSTOM1                                  'That worked out pretty well I'd say!  That over there to the left
      Select Case As Long @wc.lpnmh.code                 'looks like a complicated mess of Select Case logic, doesn't it?  Well,
        Case %MY_CUS_MSG_LBUTTON_DOWN                    'its not all that complicated.  In fact, if you would remove every
          MsgBox _                                       'remnant of the select case statements and just leave the MsgBox() the
          ( _                                            'program would still work.  What the Select Case logic does is determine
            "wParam  = " & Str$(wea.wParam) & Chr$(13) & Chr$(10) & _                     'the specific custom control ID the
            "@wc.lpnmh.hwndFrom = " & Str$(@wc.lpnmh.hwndFrom) & Chr$(13) & Chr$(10) & _  'WM_NOTIFY is coming from, and the
            "@wc.lpnmh.idFrom = " & Str$(@wc.lpnmh.idFrom) & Chr$(13) & Chr$(10) & _      'particular custom message that has
            "@wc.lpnmh.code = " & Str$(@wc.lpnmh.code) & Chr$(13) & Chr$(10) & _          'just arrived.  In this unique case
            "@wc.szColor = " & @wc.szColor _             'we only have one instance of the custom control on the main form, and
          )                                              'that particular custom control only generates one message, but in
      End Select                                         'general custom controls should be designed so that any number of them
  End Select                                             'can be instantiated on a form/dialog, and many custom controls generate

  fnWndProc_OnNotify=0                                   'many different messages.  Think of a grid for example.  A grid might
End Function                                             'generate a message when a char key is pressed, when a cursor motion...


'Event Handler For %WM_CLOSE Message                     '...key is pressed, a button clicked, etc.  That's why in general Select
Function fnWndProc_OnClose(wea As WndEventArgs) As Long  'Case logic will be used.  Note also the variable declaration.  There is
  'Call FreeLibrary(hDll)                                 'only one - 'Local wc As WindowColor Ptr'  Don't forget that when the
  Call PostQuitMessage(0)                                'custom control SendMessag()'ed us the %MY_CUS_MSG_LBUTTON_DOWN message,

  fnWndProc_OnClose=0                                    'the lParam parameter was loaded with a pointer to a WindowColor Type,
End Function                                             'i.e., Varptr(wc).  That is why pointer notation is being used to....


Function fnWndProc(ByVal hWnd As Long,ByVal wMsg As Long,ByVal wParam As Long,ByVal lParam As Long) Export As Long
  Local wea As WndEventArgs                              '...dereference the pointer variable.  Finally note how the message box

  Select Case wMsg                                       'faithfully reports to us here in the host app the 'state' of the variables
    Case %WM_CREATE                                      'in the custom control.
      wea.wParam=wParam:wea.lParam=lParam:wea.hWnd=hWnd
      fnWndProc=fnWndProc_OnCreate(wea)                  '
      Exit Function
    Case %WM_COMMAND
      wea.wParam=wParam:wea.lParam=lParam:wea.hWnd=hWnd
      fnWndProc=fnWndProc_OnCommand(wea)
      Exit Function
    Case %WM_NOTIFY
      wea.wParam=wParam:wea.lParam=lParam:wea.hWnd=hWnd
      fnWndProc=fnWndProc_OnNotify(wea)
      Exit Function
    Case %WM_CLOSE
      wea.wParam=wParam:wea.lParam=lParam:wea.hWnd=hWnd
      fnWndProc=fnWndProc_OnClose(wea)
      Exit Function
  End Select

  fnWndProc=DefWindowProc(hWnd,wMsg,wParam,lParam)
End Function


Function blnAppInitialize(hIns As Long,szClassName As Asciiz) As Dword
  Local szAppName As Asciiz*16
  Local wcl As WndClassEx

  wcl.cbSize=SizeOf(wcl)
  wcl.style=%CS_HREDRAW Or %CS_VREDRAW
  wcl.lpfnWndProc=CodePtr(fnWndProc)
  wcl.cbClsExtra=0
  wcl.cbWndExtra=0
  wcl.hInstance=hIns
  wcl.hIcon=LoadIcon(%NULL, ByVal %IDI_APPLICATION)
  wcl.hCursor=LoadCursor(%NULL, ByVal %IDC_ARROW)
  wcl.hbrBackground=%COLOR_BTNFACE+1
  wcl.lpszMenuName=%NULL
  wcl.lpszClassName=VarPtr(szClassName)
  wcl.hIconSm=LoadIcon(hIns,ByVal %IDI_APPLICATION)
  If IsFalse(RegisterClassEx(wcl)) Then
     blnAppInitialize=%FALSE
     Exit Function
  End If

  Function=%TRUE
End Function


Function WinMain(ByVal hIns As Long, ByVal hPrevIns As Long,ByVal lpCmdLine As Asciiz Ptr, ByVal iShow As Long) As Long
  Local dwStyle,hMainWnd As Dword
  Local szAppName As Asciiz*32
  Local szCaption As Asciiz*64
  Local Msg As tagMsg

  szAppName="Custom Control Test"
  szCaption="PowerBASIC Custom Control Demo"
  If blnAppInitialize(hIns,szAppName) Then    'Register App Class In blnAppInitialize()
     dwStyle=%WS_OVERLAPPEDWINDOW Xor %WS_MAXIMIZEBOX
     hMainWnd=CreateWindowEx(0,szAppName,szCaption,dwStyle,200,100,440,140,%HWND_DESKTOP,0,hIns,ByVal 0)
     Call ShowWindow(hMainWnd,iShow)
     Call UpdateWindow(hMainWnd)
     While GetMessage(Msg,%NULL,0,0)
       TranslateMessage Msg
       DispatchMessage Msg
     Wend
   End If

  Function=msg.wParam
End Function
